Project Chrono: chrono::ChAssembly Class Reference

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
chrono::ChAssembly Class Reference

## Description

Class for assemblies of physical items.

This class is a container of ChPhysicsItems items i.e. rigid bodies, shafts, links, etc. ChAssembly objects can also contain other ChAssembly objects. Location and rotation of the contained ChPhysicsItems are assumed to be expressed with respect to the absolute frame.

`#include <ChAssembly.h>`

Inheritance diagram for chrono::ChAssembly:
[legend]
Collaboration diagram for chrono::ChAssembly:
[legend]

## Public Member Functions
| ChAssembly (const ChAssembly &other)
virtual ChAssembly * | Clone () const override
| "Virtual" copy constructor (covariant return type).
ChAssembly & | operator= (ChAssembly other)
| Assignment operator for ChAssembly.
void | Clear ()
| Removes all inserted items: bodies, links, etc.
void | AddBody (std::shared_ptr< ChBody > body)
| Attach a body to this assembly.
void | AddShaft (std::shared_ptr< ChShaft > shaft)
| Attach a shaft to this assembly.
void | AddLink (std::shared_ptr< ChLinkBase > link)
| Attach a link to this assembly.
void | AddMesh (std::shared_ptr< fea::ChMesh > mesh)
| Attach a mesh to this assembly.
void | AddOtherPhysicsItem (std::shared_ptr< ChPhysicsItem > item)
| Attach a ChPhysicsItem object that is not a body, link, or mesh.
void | Add (std::shared_ptr< ChPhysicsItem > item)
| Attach an arbitrary ChPhysicsItem (e.g.
void | AddBatch (std::shared_ptr< ChPhysicsItem > item)
| Items added in this way are added like in the Add() method, but not instantly, they are simply queued in a batch of 'to add' items, that are added automatically at the first Setup() call.
void | FlushBatch ()
| If some items are queued for addition in the assembly, using AddBatch(), this will effectively add them and clean the batch.
void | RemoveBody (std::shared_ptr< ChBody > body)
| Remove a body from this assembly.
void | RemoveShaft (std::shared_ptr< ChShaft > shaft)
| Remove a shaft from this assembly.
void | RemoveLink (std::shared_ptr< ChLinkBase > link)
| Remove a link from this assembly.
void | RemoveMesh (std::shared_ptr< fea::ChMesh > mesh)
| Remove a mesh from the assembly.
void | RemoveOtherPhysicsItem (std::shared_ptr< ChPhysicsItem > item)
| Remove a ChPhysicsItem object that is not a body or a link.
void | Remove (std::shared_ptr< ChPhysicsItem > item)
| Remove arbitrary ChPhysicsItem that was added to the assembly.
void | RemoveAllBodies ()
| Remove all bodies from this assembly.
void | RemoveAllShafts ()
| Remove all shafts from this assembly.
void | RemoveAllLinks ()
| Remove all links from this assembly.
void | RemoveAllMeshes ()
| Remove all meshes from this assembly.
void | RemoveAllOtherPhysicsItems ()
| Remove all physics items not in the body, link, or mesh lists.
const std::vector< std::shared_ptr< ChBody > > & | GetBodies () const
| Get the list of bodies.
const std::vector< std::shared_ptr< ChShaft > > & | GetShafts () const
| Get the list of shafts.
const std::vector< std::shared_ptr< ChLinkBase > > & | GetLinks () const
| Get the list of links.
const std::vector< std::shared_ptr< fea::ChMesh > > & | GetMeshes () const
| Get the list of meshes.
const std::vector< std::shared_ptr< ChPhysicsItem > > & | GetOtherPhysicsItems () const
| Get the list of physics items that are not in the body or link lists.
std::shared_ptr< ChBody > | SearchBody (const std::string &name) const
| Search a body by its name.
std::shared_ptr< ChBody > | SearchBodyID (int id) const
| Search a body by its ID.
std::shared_ptr< ChShaft > | SearchShaft (const std::string &name) const
| Search a shaft by its name.
std::shared_ptr< ChLinkBase > | SearchLink (const std::string &name) const
| Search a link by its name.
std::shared_ptr< fea::ChMesh > | SearchMesh (const std::string &name) const
| Search a mesh by its name.
std::shared_ptr< ChPhysicsItem > | SearchOtherPhysicsItem (const std::string &name) const
| Search from other ChPhysics items (not bodies, links, or meshes) by name.
std::shared_ptr< ChMarker > | SearchMarker (const std::string &name) const
| Search a marker by its name.
std::shared_ptr< ChMarker > | SearchMarker (int id) const
| Search a marker by its unique ID.
std::shared_ptr< ChPhysicsItem > | Search (const std::string &name) const
| Search an item (body, link or other ChPhysics items) by name.
unsigned int | GetNumBodies () const
| Get the total number of bodies added to the assembly, including fixed and sleeping bodies.
unsigned int | GetNumBodiesActive () const
| Get the number of active bodies, excluding sleeping or fixed.
unsigned int | GetNumBodiesSleeping () const
| Get the number of sleeping bodies.
unsigned int | GetNumBodiesFixed () const
| Get the number of bodies fixed to ground.
unsigned int | GetNumShafts () const
| Get the number of shafts.
unsigned int | GetNumShaftsSleeping () const
| Get the number of shafts that are in sleeping mode (excluding fixed shafts).
unsigned int | GetNumShaftsFixed () const
| Get the number of shafts that are fixed to ground.
unsigned int | GetNumShaftsTotal () const
| Get the total number of shafts added to the assembly, including the grounded and sleeping shafts.
unsigned int | GetNumLinks () const
| Get the number of links (including non active).
unsigned int | GetNumLinksActive () const
| Get the number of active links.
unsigned int | GetNumMeshes () const
| Get the number of meshes.
unsigned int | GetNumOtherPhysicsItems () const
| Get the number of other active physics items (including non active).
unsigned int | GetNumOtherPhysicsItemsActive () const
| Get the number of other active physics items.
virtual unsigned int | GetNumCoordsPosLevel () override
| Get the number of scalar coordinates at the position level.
virtual unsigned int | GetNumCoordsVelLevel () override
| Get the number of scalar coordinates at the velocity level.
virtual unsigned int | GetNumConstraints () override
| Get the number of scalar constraints in the assembly.
virtual unsigned int | GetNumConstraintsBilateral () override
| Get the number of scalar bilateral constraints in the assembly.
virtual unsigned int | GetNumConstraintsUnilateral () override
| Get the number of scalar unilateral constraints in the assembly.
virtual void | SetSystem (ChSystem *m_system) override
| Set the pointer to the parent ChSystem() and also add to new collision system / remove from old coll.system.
virtual void | AddCollisionModelsToSystem (ChCollisionSystem *coll_sys) const override
| Add collision models (if any) for all items in the assembly to the provided collision system.
virtual void | RemoveCollisionModelsFromSystem (ChCollisionSystem *coll_sys) const override
| Remove the collision models (if any) for all items in the assembly from the provided collision system.
virtual void | SyncCollisionModels () override
| Synchronize collision models for all physics items in this assembly.
virtual void | Setup () override
| Counts the number of bodies, links, and meshes.
virtual void | Update (double mytime, bool update_assets=true) override
| Updates all the auxiliary data and children of bodies, forces, links, given their current state.
virtual void | Update (bool update_assets=true) override
| Updates all the auxiliary data and children of bodies, forces, links, given their current state.
virtual void | ForceToRest () override
| Set zero speed (and zero accelerations) in state, without changing the position.
virtual void | IntStateGather (const unsigned int off_x, ChState &x, const unsigned int off_v, ChStateDelta &v, double &T) override
| From item's state to global state vectors y={x,v} pasting the states at the specified offsets.
virtual void | IntStateScatter (const unsigned int off_x, const ChState &x, const unsigned int off_v, const ChStateDelta &v, const double T, bool full_update) override
| From global state vectors y={x,v} to item's state (and update) fetching the states at the specified offsets.
virtual void | IntStateGatherAcceleration (const unsigned int off_a, ChStateDelta &a) override
| From item's state acceleration to global acceleration vector.
virtual void | IntStateScatterAcceleration (const unsigned int off_a, const ChStateDelta &a) override
| From global acceleration vector to item's state acceleration.
virtual void | IntStateGatherReactions (const unsigned int off_L, ChVectorDynamic<> &L) override
| From item's reaction forces to global reaction vector.
virtual void | IntStateScatterReactions (const unsigned int off_L, const ChVectorDynamic<> &L) override
| From global reaction vector to item's reaction forces.
virtual void | IntStateIncrement (const unsigned int off_x, ChState &x_new, const ChState &x, const unsigned int off_v, const ChStateDelta &Dv) override
| Computes x_new = x + Dt , using vectors at specified offsets.
virtual void | IntStateGetIncrement (const unsigned int off_x, const ChState &x_new, const ChState &x, const unsigned int off_v, ChStateDelta &Dv) override
| Computes Dt = x_new - x, using vectors at specified offsets.
virtual void | IntLoadResidual_F (const unsigned int off, ChVectorDynamic<> &R, const double c) override
| Takes the F force term, scale and adds to R at given offset: R += c*F.
virtual void | IntLoadResidual_Mv (const unsigned int off, ChVectorDynamic<> &R, const ChVectorDynamic<> &w, const double c) override
| Takes the M*v term, multiplying mass by a vector, scale and adds to R at given offset: R += c*M*w.
virtual void | IntLoadLumpedMass_Md (const unsigned int off, ChVectorDynamic<> &Md, double &err, const double c) override
| Adds the lumped mass to a Md vector, representing a mass diagonal matrix.
virtual void | IntLoadResidual_CqL (const unsigned int off_L, ChVectorDynamic<> &R, const ChVectorDynamic<> &L, const double c) override
| Takes the term Cq'*L, scale and adds to R at given offset: R += c*Cq'*L.
virtual void | IntLoadConstraint_C (const unsigned int off, ChVectorDynamic<> &Qc, const double c, bool do_clamp, double recovery_clamp) override
| Takes the term C, scale and adds to Qc at given offset: Qc += c*C.
virtual void | IntLoadConstraint_Ct (const unsigned int off, ChVectorDynamic<> &Qc, const double c) override
| Takes the term Ct, scale and adds to Qc at given offset: Qc += c*Ct.
virtual void | IntToDescriptor (const unsigned int off_v, const ChStateDelta &v, const ChVectorDynamic<> &R, const unsigned int off_L, const ChVectorDynamic<> &L, const ChVectorDynamic<> &Qc) override
| Prepare variables and constraints to accommodate a solution:
virtual void | IntFromDescriptor (const unsigned int off_v, ChStateDelta &v, const unsigned int off_L, ChVectorDynamic<> &L) override
| After a solver solution, fetch values from variables and constraints into vectors:
virtual void | InjectVariables (ChSystemDescriptor &descriptor) override
| Register with the given system descriptor any ChVariable objects associated with this item.
virtual void | InjectConstraints (ChSystemDescriptor &descriptor) override
| Register with the given system descriptor any ChConstraint objects associated with this item.
virtual void | LoadConstraintJacobians () override
| Compute and load current Jacobians in encapsulated ChConstraint objects.
virtual void | InjectKRMMatrices (ChSystemDescriptor &descriptor) override
| Register with the given system descriptor any ChKRMBlock objects associated with this item.
virtual void | LoadKRMMatrices (double Kfactor, double Rfactor, double Mfactor) override
| Compute and load current stiffnes (K), damping (R), and mass (M) matrices in encapsulated ChKRMBlock objects.
virtual void | VariablesFbReset () override
| Sets the 'fb' part (the known term) of the encapsulated ChVariables to zero.
virtual void | VariablesFbLoadForces (double factor=1) override
| Adds the current forces (applied to item) into the encapsulated ChVariables, in the 'fb' part: qf+=forces*factor.
virtual void | VariablesQbLoadSpeed () override
| Initialize the 'qb' part of the ChVariables with the current value of speeds.
virtual void | VariablesFbIncrementMq () override
| Adds M*q (masses multiplied current 'qb') to Fb, ex.
virtual void | VariablesQbSetSpeed (double step=0) override
| Fetches the item speed (ex.
virtual void | VariablesQbIncrementPosition (double step) override
| Increment item positions by the 'qb' part of the ChVariables, multiplied by a 'step' factor.
virtual void | ConstraintsBiReset () override
| Sets to zero the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_C (double factor=1, double recovery_clamp=0.1, bool do_clamp=false) override
| Adds the current C (constraint violation) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_Ct (double factor=1) override
| Adds the current Ct (partial t-derivative, as in C_dt=0-> [Cq]*q_dt=-Ct) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_Qc (double factor=1) override
| Adds the current Qc (the vector of C_dtdt=0 -> [Cq]*q_dtdt=Qc ) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsFbLoadForces (double factor=1) override
| Adds the current link-forces, if any, (caused by springs, etc.) to the 'fb' vectors of the ChVariables referenced by encapsulated ChConstraints.
virtual void | ConstraintsFetch_react (double factor=1) override
| Fetches the reactions from the lagrangian multiplier (l_i) of encapsulated ChConstraints.
void | ShowHierarchy (std::ostream &outstream, int level=0) const
| Writes the hierarchy of contained bodies, markers, etc.
virtual void | ArchiveOut (ChArchiveOut &archive_out) override
| Method to allow serialization of transient data to archives.
virtual void | ArchiveIn (ChArchiveIn &archive_in) override
| Method to allow deserialization of transient data from archives.
Public Member Functions inherited from chrono::ChPhysicsItem
| ChPhysicsItem (const ChPhysicsItem &other)
ChSystem * | GetSystem () const
| Get the pointer to the parent ChSystem().
void | AddVisualModel (std::shared_ptr< ChVisualModel > model)
| Add an (optional) visualization model.
std::shared_ptr< ChVisualModel > | GetVisualModel () const
| Access the visualization model (if any).
void | AddVisualShape (std::shared_ptr< ChVisualShape > shape, const ChFrame<> &frame=ChFrame<>())
| Add the specified visual shape to the visualization model.
std::shared_ptr< ChVisualShape > | GetVisualShape (unsigned int i) const
| Access the specified visualization shape in the visualization model (if any).
void | AddVisualShapeFEA (std::shared_ptr< ChVisualShapeFEA > shapeFEA)
| Add the specified FEA visualization object to the visualization model.
std::shared_ptr< ChVisualShapeFEA > | GetVisualShapeFEA (unsigned int i) const
| Access the specified FEA visualization object in the visualization model (if any).
virtual ChFrame | GetVisualModelFrame (unsigned int nclone=0) const
| Get the reference frame (expressed in and relative to the absolute frame) of the visual model.
virtual unsigned int | GetNumVisualModelClones () const
| Return the number of clones of the visual model associated with this physics item.
void | AddCamera (std::shared_ptr< ChCamera > camera)
| Attach a ChCamera to this physical item.
std::vector< std::shared_ptr< ChCamera > > | GetCameras () const
| Get the set of cameras attached to this physics item.
virtual bool | IsActive () const
| Return true if the object is active and included in dynamics.
virtual bool | IsCollisionEnabled () const
| Tell if the object is subject to collision.
virtual ChAABB | GetTotalAABB ()
| Get the entire AABB axis-aligned bounding box of the object.
virtual void | GetCenter (ChVector3d &mcenter)
| Get a symbolic 'center' of the object.
unsigned int | GetOffset_x ()
| Get offset in the state vector (position part).
unsigned int | GetOffset_w ()
| Get offset in the state vector (speed part).
unsigned int | GetOffset_L ()
| Get offset in the lagrangian multipliers.
void | SetOffset_x (const unsigned int moff)
| Set offset in the state vector (position part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_w (const unsigned int moff)
| Set offset in the state vector (speed part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_L (const unsigned int moff)
| Set offset in the lagrangian multipliers Note: only the ChSystem::Setup function should use this.
Public Member Functions inherited from chrono::ChObj
| ChObj (const ChObj &other)
int | GetIdentifier () const
| Get the unique integer identifier of this object.
void | SetTag (int tag)
| Set an object integer tag (default: -1).
int | GetTag () const
| Get the tag of this object.
void | SetName (const std::string &myname)
| Set the name of this object.
const std::string & | GetName () const
| Get the name of this object.
double | GetChTime () const
| Gets the simulation time of this object.
void | SetChTime (double m_time)
| Sets the simulation time of this object.
virtual std::string & | ArchiveContainerName ()

## Protected Member Functions
virtual void | SetupInitial () override
Protected Member Functions inherited from chrono::ChObj
int | GenerateUniqueIdentifier ()

## Protected Attributes
std::vector< std::shared_ptr< ChBody > > | bodylist
| list of rigid bodies
std::vector< std::shared_ptr< ChShaft > > | shaftlist
| list of 1-D shafts
std::vector< std::shared_ptr< ChLinkBase > > | linklist
| list of joints (links)
std::vector< std::shared_ptr< fea::ChMesh > > | meshlist
| list of meshes
std::vector< std::shared_ptr< ChPhysicsItem > > | otherphysicslist
| list of other physics objects
std::vector< std::shared_ptr< ChPhysicsItem > > | batch_to_insert
| list of items to insert at once
unsigned int | m_num_bodies_active
| number of active bodies
unsigned int | m_num_bodies_sleep
| number of sleeping bodies
unsigned int | m_num_bodies_fixed
| number of fixed bodies
unsigned int | m_num_shafts
| number of active shafts
unsigned int | m_num_shafts_sleep
| number of sleeping shafts
unsigned int | m_num_shafts_fixed
| number of fixed shafts
unsigned int | m_num_links_active
| number of active links
unsigned int | m_num_meshes
| number of meshes
unsigned int | m_num_otherphysicsitems_active
| number of other active physics items
unsigned int | m_num_coords_pos
| number of scalar position-level coordinates for all active bodies
unsigned int | m_num_coords_vel
| number of scalar velocity-level coordinates for all active bodies
unsigned int | m_num_constr
| number of scalar constraints
unsigned int | m_num_constr_bil
| number of scalar bilateral constraints
unsigned int | m_num_constr_uni
| number of scalar unilateral constraints
Protected Attributes inherited from chrono::ChPhysicsItem
ChSystem * | system
| parent system
std::shared_ptr< ChVisualModelInstance > | vis_model_instance
| instantiated visualization model
std::vector< std::shared_ptr< ChCamera > > | cameras
| set of cameras
unsigned int | offset_x
| offset in vector of state (position part)
unsigned int | offset_w
| offset in vector of state (speed part)
unsigned int | offset_L
| offset in vector of lagrangian multipliers
Protected Attributes inherited from chrono::ChObj
double | ChTime
| object simulation time
std::string | m_name
| object name
int | m_identifier
| object unique identifier
int | m_tag
| user-supplied tag

## Friends
class | ChSystem
class | ChSystemMulticore
ChApi void | swap (ChAssembly &first, ChAssembly &second)
| Swap the contents of the two provided ChAssembly objects.

## Member Function Documentation

## ◆ Add()

void chrono::ChAssembly::Add | ( | std::shared_ptr< ChPhysicsItem > | item | ) |

Attach an arbitrary ChPhysicsItem (e.g.

ChBody, ChParticles, ChLink, etc.) to the assembly. It will take care of adding it to the proper list of bodies, links, meshes, or generic physic item. (i.e. it calls AddBody(), AddShaft(), AddLink(), AddMesh(), or AddOtherPhysicsItem()). Note, you cannot call Add() during an Update (i.e. items like particle generators that are already inserted in the assembly cannot call this) because not thread safe; instead, use AddBatch().

## ◆ AddBatch()

void chrono::ChAssembly::AddBatch | ( | std::shared_ptr< ChPhysicsItem > | item | ) |

Items added in this way are added like in the Add() method, but not instantly, they are simply queued in a batch of 'to add' items, that are added automatically at the first Setup() call.

This is thread safe.

## ◆ AddCollisionModelsToSystem()

void chrono::ChAssembly::AddCollisionModelsToSystem | ( | ChCollisionSystem * | coll_sys | ) | const
| overridevirtual

Add collision models (if any) for all items in the assembly to the provided collision system.

Reimplemented from chrono::ChPhysicsItem.

## ◆ ArchiveIn()

void chrono::ChAssembly::ArchiveIn | ( | ChArchiveIn & | archive_in | ) |
| overridevirtual

Method to allow deserialization of transient data from archives.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ ArchiveOut()

void chrono::ChAssembly::ArchiveOut | ( | ChArchiveOut & | archive_out | ) |
| overridevirtual

Method to allow serialization of transient data to archives.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ Clone()

virtual ChAssembly * chrono::ChAssembly::Clone | ( |  | ) | const
| inlineoverridevirtual

"Virtual" copy constructor (covariant return type).

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ ConstraintsBiLoad_C()

void chrono::ChAssembly::ConstraintsBiLoad_C | ( | double | factor = 1,
|  | double | recovery_clamp = 0.1,
|  | bool | do_clamp = false )
| overridevirtual

Adds the current C (constraint violation) to the known term (b_i) of encapsulated ChConstraints.

Reimplemented from chrono::ChPhysicsItem.

## ◆ ConstraintsBiLoad_Ct()

void chrono::ChAssembly::ConstraintsBiLoad_Ct | ( | double | factor = 1 | ) |
| overridevirtual

Adds the current Ct (partial t-derivative, as in C_dt=0-> [Cq]*q_dt=-Ct) to the known term (b_i) of encapsulated ChConstraints.

Reimplemented from chrono::ChPhysicsItem.

## ◆ ConstraintsBiLoad_Qc()

void chrono::ChAssembly::ConstraintsBiLoad_Qc | ( | double | factor = 1 | ) |
| overridevirtual

Adds the current Qc (the vector of C_dtdt=0 -> [Cq]*q_dtdt=Qc ) to the known term (b_i) of encapsulated ChConstraints.

Reimplemented from chrono::ChPhysicsItem.

## ◆ ConstraintsBiReset()

void chrono::ChAssembly::ConstraintsBiReset | ( |  | ) |
| overridevirtual

Sets to zero the known term (b_i) of encapsulated ChConstraints.

Reimplemented from chrono::ChPhysicsItem.

## ◆ ConstraintsFbLoadForces()

void chrono::ChAssembly::ConstraintsFbLoadForces | ( | double | factor = 1 | ) |
| overridevirtual

Adds the current link-forces, if any, (caused by springs, etc.) to the 'fb' vectors of the ChVariables referenced by encapsulated ChConstraints.

Reimplemented from chrono::ChPhysicsItem.

## ◆ ConstraintsFetch_react()

void chrono::ChAssembly::ConstraintsFetch_react | ( | double | factor = 1 | ) |
| overridevirtual

Fetches the reactions from the lagrangian multiplier (l_i) of encapsulated ChConstraints.

Mostly used after the solver provided the solution in ChConstraints. Also, should convert the reactions obtained from dynamical simulation, from link space to intuitive react_force and react_torque.

Reimplemented from chrono::ChPhysicsItem.

## ◆ FlushBatch()

void chrono::ChAssembly::FlushBatch | ( |  | ) |

If some items are queued for addition in the assembly, using AddBatch(), this will effectively add them and clean the batch.

Called automatically at each Setup().

## ◆ ForceToRest()

void chrono::ChAssembly::ForceToRest | ( |  | ) |
| overridevirtual

Set zero speed (and zero accelerations) in state, without changing the position.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ GetNumConstraints()

virtual unsigned int chrono::ChAssembly::GetNumConstraints | ( |  | ) |
| inlineoverridevirtual

Get the number of scalar constraints in the assembly.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ GetNumConstraintsBilateral()

virtual unsigned int chrono::ChAssembly::GetNumConstraintsBilateral | ( |  | ) |
| inlineoverridevirtual

Get the number of scalar bilateral constraints in the assembly.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ GetNumConstraintsUnilateral()

virtual unsigned int chrono::ChAssembly::GetNumConstraintsUnilateral | ( |  | ) |
| inlineoverridevirtual

Get the number of scalar unilateral constraints in the assembly.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ GetNumCoordsPosLevel()

virtual unsigned int chrono::ChAssembly::GetNumCoordsPosLevel | ( |  | ) |
| inlineoverridevirtual

Get the number of scalar coordinates at the position level.

This count includes the 4th dimension of quaternions (if any), thus potentially differing from GetNumCoordsVelLevel().

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ GetNumCoordsVelLevel()

virtual unsigned int chrono::ChAssembly::GetNumCoordsVelLevel | ( |  | ) |
| inlineoverridevirtual

Get the number of scalar coordinates at the velocity level.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ InjectConstraints()

void chrono::ChAssembly::InjectConstraints | ( | ChSystemDescriptor & | descriptor | ) |
| overridevirtual

Register with the given system descriptor any ChConstraint objects associated with this item.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ InjectKRMMatrices()

void chrono::ChAssembly::InjectKRMMatrices | ( | ChSystemDescriptor & | descriptor | ) |
| overridevirtual

Register with the given system descriptor any ChKRMBlock objects associated with this item.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ InjectVariables()

void chrono::ChAssembly::InjectVariables | ( | ChSystemDescriptor & | descriptor | ) |
| overridevirtual

Register with the given system descriptor any ChVariable objects associated with this item.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ IntFromDescriptor()

void chrono::ChAssembly::IntFromDescriptor | ( | const unsigned int | off_v,
|  | ChStateDelta & | v,
|  | const unsigned int | off_L,
|  | ChVectorDynamic<> & | L )
| overridevirtual

After a solver solution, fetch values from variables and constraints into vectors:

Parameters

  off_v | offset for v
  v | vector to where the q 'unknowns' term of the variables will be copied
  off_L | offset for L
  L | vector to where L 'lagrangian ' term of the constraints will be copied

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntLoadConstraint_C()

void chrono::ChAssembly::IntLoadConstraint_C | ( | const unsigned int | off,
|  | ChVectorDynamic<> & | Qc,
|  | const double | c,
|  | bool | do_clamp,
|  | double | recovery_clamp )
| overridevirtual

Takes the term C, scale and adds to Qc at given offset: Qc += c*C.

Parameters

  off | offset in Qc residual
  Qc | result: the Qc residual, Qc += c*C
  c | a scaling factor
  do_clamp | apply clamping to c*C?
  recovery_clamp | value for min/max clamping of c*C

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntLoadConstraint_Ct()

void chrono::ChAssembly::IntLoadConstraint_Ct | ( | const unsigned int | off,
|  | ChVectorDynamic<> & | Qc,
|  | const double | c )
| overridevirtual

Takes the term Ct, scale and adds to Qc at given offset: Qc += c*Ct.

Parameters

  off | offset in Qc residual
  Qc | result: the Qc residual, Qc += c*Ct
  c | a scaling factor

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntLoadLumpedMass_Md()

void chrono::ChAssembly::IntLoadLumpedMass_Md | ( | const unsigned int | off,
|  | ChVectorDynamic<> & | Md,
|  | double & | err,
|  | const double | c )
| overridevirtual

Adds the lumped mass to a Md vector, representing a mass diagonal matrix.

Used by lumped explicit integrators. If mass lumping is impossible or approximate, adds scalar error to "error" parameter. Md += c*diag(M)

Parameters

  off | offset in Md vector
  Md | result: Md vector, diagonal of the lumped mass matrix
  err | result: not touched if lumping does not introduce errors
  c | a scaling factor

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntLoadResidual_CqL()

void chrono::ChAssembly::IntLoadResidual_CqL | ( | const unsigned int | off_L,
|  | ChVectorDynamic<> & | R,
|  | const ChVectorDynamic<> & | L,
|  | const double | c )
| overridevirtual

Takes the term Cq'*L, scale and adds to R at given offset: R += c*Cq'*L.

Parameters

  off_L | offset in L multipliers
  R | result: the R residual, R += c*Cq'*L
  L | the L vector
  c | a scaling factor

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntLoadResidual_F()

void chrono::ChAssembly::IntLoadResidual_F | ( | const unsigned int | off,
|  | ChVectorDynamic<> & | R,
|  | const double | c )
| overridevirtual

Takes the F force term, scale and adds to R at given offset: R += c*F.

Parameters

  off | offset in R residual
  R | result: the R residual, R += c*F
  c | a scaling factor

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntLoadResidual_Mv()

void chrono::ChAssembly::IntLoadResidual_Mv | ( | const unsigned int | off,
|  | ChVectorDynamic<> & | R,
|  | const ChVectorDynamic<> & | w,
|  | const double | c )
| overridevirtual

Takes the M*v term, multiplying mass by a vector, scale and adds to R at given offset: R += c*M*w.

Parameters

  off | offset in R residual
  R | result: the R residual, R += c*M*v
  w | the w vector
  c | a scaling factor

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntStateGather()

void chrono::ChAssembly::IntStateGather | ( | const unsigned int | off_x,
|  | ChState & | x,
|  | const unsigned int | off_v,
|  | ChStateDelta & | v,
|  | double & | T )
| overridevirtual

From item's state to global state vectors y={x,v} pasting the states at the specified offsets.

Parameters

  off_x | offset in x state vector
  x | state vector, position part
  off_v | offset in v state vector
  v | state vector, speed part
  T | time

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ IntStateGatherAcceleration()

void chrono::ChAssembly::IntStateGatherAcceleration | ( | const unsigned int | off_a,
|  | ChStateDelta & | a )
| overridevirtual

From item's state acceleration to global acceleration vector.

Parameters

  off_a | offset in a accel. vector
  a | acceleration part of state vector derivative

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ IntStateGatherReactions()

void chrono::ChAssembly::IntStateGatherReactions | ( | const unsigned int | off_L,
|  | ChVectorDynamic<> & | L )
| overridevirtual

From item's reaction forces to global reaction vector.

Parameters

  off_L | offset in L vector
  L | L vector of reaction forces

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntStateGetIncrement()

void chrono::ChAssembly::IntStateGetIncrement | ( | const unsigned int | off_x,
|  | const ChState & | x_new,
|  | const ChState & | x,
|  | const unsigned int | off_v,
|  | ChStateDelta & | Dv )
| overridevirtual

Computes Dt = x_new - x, using vectors at specified offsets.

By default, when DOF = DOF_w, it does just the difference of two state vectors, but in some cases (ex when using quaternions for rotations) it could do more complex stuff, and children classes might overload it.

Parameters

  off_x | offset in x state vector
  x_new | state vector, final position part
  x | state vector, initial position part
  off_v | offset in v state vector
  Dv | state vector, increment. Here gets the result

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ IntStateIncrement()

void chrono::ChAssembly::IntStateIncrement | ( | const unsigned int | off_x,
|  | ChState & | x_new,
|  | const ChState & | x,
|  | const unsigned int | off_v,
|  | const ChStateDelta & | Dv )
| overridevirtual

Computes x_new = x + Dt , using vectors at specified offsets.

By default, when DOF = DOF_w, it does just the sum, but in some cases (ex when using quaternions for rotations) it could do more complex stuff, and children classes might overload it.

Parameters

  off_x | offset in x state vector
  x_new | state vector, position part, incremented result
  x | state vector, initial position part
  off_v | offset in v state vector
  Dv | state vector, increment

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ IntStateScatter()

void chrono::ChAssembly::IntStateScatter | ( | const unsigned int | off_x,
|  | const ChState & | x,
|  | const unsigned int | off_v,
|  | const ChStateDelta & | v,
|  | const double | T,
|  | bool | full_update )
| overridevirtual

From global state vectors y={x,v} to item's state (and update) fetching the states at the specified offsets.

Parameters

  off_x | offset in x state vector
  x | state vector, position part
  off_v | offset in v state vector
  v | state vector, speed part
  T | time
  full_update | perform complete update

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ IntStateScatterAcceleration()

void chrono::ChAssembly::IntStateScatterAcceleration | ( | const unsigned int | off_a,
|  | const ChStateDelta & | a )
| overridevirtual

From global acceleration vector to item's state acceleration.

Parameters

  off_a | offset in a accel. vector
  a | acceleration part of state vector derivative

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ IntStateScatterReactions()

void chrono::ChAssembly::IntStateScatterReactions | ( | const unsigned int | off_L,
|  | const ChVectorDynamic<> & | L )
| overridevirtual

From global reaction vector to item's reaction forces.

Parameters

  off_L | offset in L vector
  L | L vector of reaction forces

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntToDescriptor()

void chrono::ChAssembly::IntToDescriptor | ( | const unsigned int | off_v,
|  | const ChStateDelta & | v,
|  | const ChVectorDynamic<> & | R,
|  | const unsigned int | off_L,
|  | const ChVectorDynamic<> & | L,
|  | const ChVectorDynamic<> & | Qc )
| overridevirtual

Prepare variables and constraints to accommodate a solution:

Parameters

  off_v | offset for v and R
  v | vector copied into the q 'unknowns' term of the variables
  R | vector copied into the F 'force' term of the variables
  off_L | offset for L and Qc
  L | vector copied into the L 'lagrangian ' term of the constraints
  Qc | vector copied into the Qb 'constraint' term of the constraints

Reimplemented from chrono::ChPhysicsItem.

## ◆ LoadConstraintJacobians()

void chrono::ChAssembly::LoadConstraintJacobians | ( |  | ) |
| overridevirtual

Compute and load current Jacobians in encapsulated ChConstraint objects.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ LoadKRMMatrices()

void chrono::ChAssembly::LoadKRMMatrices | ( | double | Kfactor,
|  | double | Rfactor,
|  | double | Mfactor )
| overridevirtual

Compute and load current stiffnes (K), damping (R), and mass (M) matrices in encapsulated ChKRMBlock objects.

The resulting KRM blocks represent linear combinations of the K, R, and M matrices, with the specified coefficients Kfactor, Rfactor,and Mfactor, respectively. Note: signs are flipped from the term dF/dx in the integrator: K = -dF/dq and R = -dF/dv.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ RemoveCollisionModelsFromSystem()

void chrono::ChAssembly::RemoveCollisionModelsFromSystem | ( | ChCollisionSystem * | coll_sys | ) | const
| overridevirtual

Remove the collision models (if any) for all items in the assembly from the provided collision system.

Reimplemented from chrono::ChPhysicsItem.

## ◆ SetSystem()

void chrono::ChAssembly::SetSystem | ( | ChSystem * | m_system | ) |
| overridevirtual

Set the pointer to the parent ChSystem() and also add to new collision system / remove from old coll.system.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ Setup()

void chrono::ChAssembly::Setup | ( |  | ) |
| overridevirtual

Counts the number of bodies, links, and meshes.

Computes the offsets of object states in the global state. Assumes that this->offset_x this->offset_w this->offset_L are already set as starting point for offsetting all the contained sub objects.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ SetupInitial()

void chrono::ChAssembly::SetupInitial | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from chrono::ChPhysicsItem.

## ◆ ShowHierarchy()

void chrono::ChAssembly::ShowHierarchy | ( | std::ostream & | outstream,
|  | int | level = 0 ) const

Writes the hierarchy of contained bodies, markers, etc.

in ASCII readable form, mostly for debugging purposes. Level is the tab spacing at the left.

## ◆ SyncCollisionModels()

void chrono::ChAssembly::SyncCollisionModels | ( |  | ) |
| overridevirtual

Synchronize collision models for all physics items in this assembly.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ Update() [1/2]

void chrono::ChAssembly::Update | ( | bool | update_assets = true | ) |
| overridevirtual

Updates all the auxiliary data and children of bodies, forces, links, given their current state.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::modal::ChModalAssembly.

## ◆ Update() [2/2]

void chrono::ChAssembly::Update | ( | double | mytime,
|  | bool | update_assets = true )
| overridevirtual

Updates all the auxiliary data and children of bodies, forces, links, given their current state.

Reimplemented from chrono::ChPhysicsItem.

## ◆ VariablesFbIncrementMq()

void chrono::ChAssembly::VariablesFbIncrementMq | ( |  | ) |
| overridevirtual

Adds M*q (masses multiplied current 'qb') to Fb, ex.

if qb is initialized with v_old using VariablesQbLoadSpeed, this method can be used in timestepping schemes that do: M*v_new = M*v_old + forces*dt

Reimplemented from chrono::ChPhysicsItem.

## ◆ VariablesFbLoadForces()

void chrono::ChAssembly::VariablesFbLoadForces | ( | double | factor = 1 | ) |
| overridevirtual

Adds the current forces (applied to item) into the encapsulated ChVariables, in the 'fb' part: qf+=forces*factor.

Reimplemented from chrono::ChPhysicsItem.

## ◆ VariablesFbReset()

void chrono::ChAssembly::VariablesFbReset | ( |  | ) |
| overridevirtual

Sets the 'fb' part (the known term) of the encapsulated ChVariables to zero.

Reimplemented from chrono::ChPhysicsItem.

## ◆ VariablesQbIncrementPosition()

void chrono::ChAssembly::VariablesQbIncrementPosition | ( | double | step | ) |
| overridevirtual

Increment item positions by the 'qb' part of the ChVariables, multiplied by a 'step' factor.

pos+=qb*step If qb is a speed, this behaves like a single step of 1-st order numerical integration (Euler integration).

Reimplemented from chrono::ChPhysicsItem.

## ◆ VariablesQbLoadSpeed()

void chrono::ChAssembly::VariablesQbLoadSpeed | ( |  | ) |
| overridevirtual

Initialize the 'qb' part of the ChVariables with the current value of speeds.

Note: since 'qb' is the unknown, this function seems unnecessary, unless used before VariablesFbIncrementMq()

Reimplemented from chrono::ChPhysicsItem.

## ◆ VariablesQbSetSpeed()

void chrono::ChAssembly::VariablesQbSetSpeed | ( | double | step = 0 | ) |
| overridevirtual

Fetches the item speed (ex.

linear and angular vel.in rigid bodies) from the 'qb' part of the ChVariables and sets it as the current item speed. If 'step' is not 0, also should compute the approximate acceleration of the item using backward differences, that is accel=(new_speed-old_speed)/step. Mostly used after the solver provided the solution in ChVariables.

Reimplemented from chrono::ChPhysicsItem.

## Friends And Related Symbol Documentation

## ◆ swap

ChApi void swap | ( | ChAssembly & | first,
|  | ChAssembly & | second )
| friend

Swap the contents of the two provided ChAssembly objects.

Implemented as a friend (as opposed to a member function) so classes with a ChAssembly member can use ADL when implementing their own swap.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChAssembly.h
- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChAssembly.cpp